
%define with_postgresql 0

%define perl_vendorarch %(eval "`%{_bindir}/perl -V:installvendorarch`"; echo $installvendorarch)
%define perl_vendorarch64 %(eval "`%{_bindir}/perl_64bit -V:installvendorarch`"; echo $installvendorarch)

%define _libdir64 %{_prefix}/lib64

Name:           uuid
Version:        1.6.2
Release:        2
Summary:        Universally Unique Identifier library
License:        MIT
Group:          System Environment/Libraries
URL:            http://www.ossp.org/pkg/lib/uuid/
Source0:        ftp://ftp.ossp.org/pkg/lib/uuid/%{name}-%{version}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
OSSP uuid is a ISO-C:1999 application programming interface (API)
and corresponding command line interface (CLI) for the generation
of DCE 1.1, ISO/IEC 11578:1996 and RFC 4122 compliant Universally
Unique Identifier (UUID). It supports DCE 1.1 variant UUIDs of version
1 (time and node based), version 3 (name based, MD5), version 4
(random number based) and version 5 (name based, SHA-1). Additional
API bindings are provided for the languages ISO-C++:1998, Perl:5 and
PHP:4/5. Optional backward compatibility exists for the ISO-C DCE-1.1
and Perl Data::UUID APIs.


%package devel
Summary:        Development support for Universally Unique Identifier library
Group:          Development/Libraries
Requires:       pkg-config
Requires:       %{name} = %{version}-%{release}

%description devel
Development headers and libraries for uuid.


%package c++
Summary:        C++ support for Universally Unique Identifier library
Group:          System Environment/Libraries
Requires:       %{name} = %{version}-%{release}

%description c++
C++ libraries for uuid.


%package c++-devel
Summary:        C++ development support for Universally Unique Identifier library
Group:          Development/Libraries
Requires:       %{name}-c++ = %{version}-%{release}
Requires:       %{name}-devel = %{version}-%{release}

%description c++-devel
C++ development headers and libraries for uuid.


%package perl
Summary:        Perl support for Universally Unique Identifier library
Group:          Development/Libraries
BuildRequires:  perl >= 5.8.8-2
Requires:       perl(:MODULE_COMPAT_%(eval "`%{_bindir}/perl -V:version`"; echo $version))
Requires:       perl >= 5.8.8-2
Requires:       %{name} = %{version}-%{release}

%description perl
Perl uuid modules, which includes a Data::UUID replacement.


%if %{with_postgresql}
%package postgresql
Summary:        PostgreSQL support for Universally Unique Identifier library
Group:          Development/Libraries
BuildRequires:  postgresql-devel
Requires:       postgresql
Requires:       %{name} = %{version}-%{release}

%description postgresql
PostgreSQL uuid module.
%endif


%package dce
Summary:        DCE support for Universally Unique Identifier library
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description dce
DCE uuid library.


%package dce-devel
Summary:        DCE development support for Universally Unique Identifier library
Group:          Development/Libraries
Requires:       %{name}-dce = %{version}-%{release}
Requires:       %{name}-devel = %{version}-%{release}

%description dce-devel
DCE development headers and libraries for uuid.


%prep
%setup -q
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --with-cxx \
    --with-dce \
    --without-perl \
    --without-php \
%if %{with_postgresql}
    --with-pgsql
%endif

make %{?_smp_mflags}

# build the Perl module.
cd perl
%{_bindir}/perl_64bit Makefile.PL INSTALLDIRS=vendor OPTIMIZE="$RPM_OPT_FLAGS" COMPAT=1
%{_bindir}/perl_64bit -pi -e 's/^\tLD_RUN_PATH=[^\s]+\s*/\t/' Makefile
make %{?_smp_mflags}

cd ../../32bit
# now build the 32-bit version
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --with-cxx \
    --with-dce \
    --without-perl \
    --without-php \
%if %{with_postgresql}
    --with-pgsql
%endif

make %{?_smp_mflags}

# build the Perl module.
cd perl
%{_bindir}/perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="$RPM_OPT_FLAGS" COMPAT=1
%{_bindir}/perl -pi -e 's/^\tLD_RUN_PATH=[^\s]+\s*/\t/' Makefile
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make install DESTDIR=${RPM_BUILD_ROOT}

# install the Perl modules
cd perl
make pure_install PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}

find ${RPM_BUILD_ROOT} -type f -name '*.bs' -size 0 -exec rm -f {} \;
find ${RPM_BUILD_ROOT} -type f -name .packlist -exec rm -f {} \;
find ${RPM_BUILD_ROOT} -depth -type d -exec rmdir {} 2>/dev/null \;
chmod -R u+w ${RPM_BUILD_ROOT}/*

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

# install the Perl modules
cd perl
make pure_install PERL_INSTALL_ROOT=${RPM_BUILD_ROOT}

find ${RPM_BUILD_ROOT} -type f -name '*.bs' -size 0 -exec rm -f {} \;
find ${RPM_BUILD_ROOT} -type f -name .packlist -exec rm -f {} \;
find ${RPM_BUILD_ROOT} -depth -type d -exec rmdir {} 2>/dev/null \;
chmod -R u+w ${RPM_BUILD_ROOT}/*

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
for f in uuid uuid++ uuid_dce ; do
    /usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib${f}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib${f}.so*
done

# there are NO symlinks to /usr/{bin,lib,lib64,include} as this might collide
# with AIX /usr/include/uuid.h etc. which exists at least for
# AIX 6.1 TL06 and AIX 7.1 TL00 and higher

(
  cd ${RPM_BUILD_ROOT}%{_includedir}
  mkdir uuid
  cd uuid
  ln -s ../uuid.h .
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/AUTHORS 32bit/ChangeLog 32bit/HISTORY 32bit/NEWS 32bit/PORTING
%doc 32bit/README 32bit/SEEALSO 32bit/THANKS 32bit/TODO 32bit/USERS
%{_bindir}/uuid
%{_libdir}/libuuid.a
%{_libdir}/libuuid.so*
%{_libdir64}/libuuid.so*
%{_mandir}/man1/uuid.*


%files devel
%defattr(-,root,system,-)
%{_bindir}/uuid-config
%{_includedir}/uuid.h
%{_includedir}/uuid/uuid.h
%{_libdir}/libuuid.la
%{_libdir64}/libuuid.la
%{_libdir}/pkgconfig/uuid.pc
%{_libdir64}/pkgconfig/uuid.pc
%{_mandir}/man1/uuid-config.*
%{_mandir}/man3/uuid.*


%files c++
%defattr(-,root,system,-)
%{_libdir}/libuuid++.a
%{_libdir}/libuuid++.so*
%{_libdir64}/libuuid++.so*


%files c++-devel
%defattr(-,root,system,-)
%{_includedir}/uuid++.hh
%{_libdir}/libuuid++.la
%{_libdir64}/libuuid++.la
%{_mandir}/man3/uuid++.*


%files perl
%defattr(-,root,system,-)
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Data*
%{perl_vendorarch}/OSSP*
%{_mandir}/man3/Data::UUID.3*
%{_mandir}/man3/OSSP::uuid.3*


%if %{with_postgresql}
%files postgresql
%defattr(-,root,system,-)
%{_libdir}/postgresql/*
%{_datadir}/postgresql/*
%endif


%files dce
%defattr(-,root,system,-)
%{_libdir}/libuuid_dce.a
%{_libdir}/libuuid_dce.so*
%{_libdir64}/libuuid_dce.so*


%files dce-devel
%defattr(-,root,system,-)
%{_includedir}/uuid_dce.h
%{_libdir}/libuuid_dce.la
%{_libdir64}/libuuid_dce.la


%changelog
* Mon Oct 27 2014 Michael Perzl <michael@perzl.org> - 1.6.2-2
- fixed some shared library inconsistencies

* Thu Jun 28 2012 Michael Perzl <michael@perzl.org> - 1.6.2-1
- first version for AIX5L V5.1 and higher
